#import "descriptors.h"
#import <appkit/appkit.h>
#import <misckit/MiscProtocols.h>

@interface Article:Cell
{
    headerDesc myHeader;
    long myNumber;
    BOOL unread;
    BOOL killed;
    int myTag;
    int size;
	int	lines;
    time_t timeOfPosting;
    char *authorRealName;
}

+ prefsChanged;

- initWithNumber:(long)number;
- composeTitle;
- parseHeader:(NXStream *)headerStream;
- free;

- (long)number;
- (headerDesc *)header;
- (time_t)time;
- (const char *)realName;

- setRead;
- setUnread;
- (BOOL)isRead;
- kill;
- unkill;
- (BOOL)isKilled;
- setTextAttributes:textObj;

- setTag;
- unsetTag;
- (BOOL)isTaged;

- (BOOL)fgrep:(const char *)pattern;

- (int)size;
- setSize:(int)asize;

- (int)lines;
- setLines:(int)lineCount;

- setSortType:(int)t;

@end

